//+------------------------------------------------------------------+
//|                                                       Magnit.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
//---- input parameters
extern int       period=14;
//---- buffers
double Magnit[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Magnit);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
     double ma1=iMA(NULL,0,period,0,0,1,i);
     double ma2=iMA(NULL,0,period*2,0,0,1,i);
     double ma3=iMA(NULL,0,period*3,0,0,1,i);
     double delta1=MathAbs(iOpen(NULL,0,i)-ma1);
     double delta2=MathAbs(iOpen(NULL,0,i)-ma2);
     double delta3=MathAbs(iOpen(NULL,0,i)-ma3);
     if(delta1==0)delta1=Point;
     if(delta2==0)delta2=Point;
     if(delta3==0)delta3=Point;
     double k1=1/delta1;
     double k2=1/delta2;
     double k3=1/delta3;
     Magnit[i]=((ma1*k1)+(ma2*k2)+(ma3*k3))/(k1+k2+k3);
     }
   return(0);
  }
//+------------------------------------------------------------------+